package com.bwie.room.scheduled;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.domain.Log;
import com.bwie.common.domain.User;
import com.bwie.common.utils.JwtUtils;
import com.bwie.room.service.impl.RoomServiceImpl;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
@Component
public class Duled {
    //使用定时任务每30秒自动审批用户贷款申请（5分）
// 审批实际上就是根据用户的信用分来进行计算，每100信用分可享受月供1000元额度。  根据贷款总价/合约周期计算月供额度是否足够，足够则审批通过，不够则审批不通过（5分）
//信用积分手动修改数据库，0-100：享受月供1000额度，100-200：享受月供2000						额度，以此累计，每100积分，享受1000月供额度
//  审批通过、审核驳回
//审核驳回需要给申请人发送通知信息，通知消息格式自定，消息方式自定（3分）
//发送消息需使用MQ进行异步发送（5分）
//并解决消息丢失问题（2分）
    @Autowired
    private StringRedisTemplate redisTemplate;
    @Autowired
    private HttpServletRequest request;
    @Autowired
    private RoomServiceImpl roomService;
    @Autowired
    private RabbitTemplate template;

    String token = request.getHeader( "token" );
    String userKey = JwtUtils.getUserKey( token );
    String s = redisTemplate.opsForValue().get( "token:" + userKey );
    User user = JSONObject.parseObject( s, User.class );
    @Scheduled(cron = "0/30 * * * * ?")
    public void xxx(){
        if(s!=null){
            Integer userCredit = user.getUserCredit();
            Integer userMoney = user.getUserMoney();
            int i = userCredit * 10;
            List<Log> logs = roomService.logList();
            for (Log log : logs) {
                if(log.getLogRoomPrice()>i && log.getLogRoomPrice()>userMoney){
//                审核驳回
                    roomService.updLogByIdOne( log.getLogId() );
                    System.out.println("审核驳回");
                    template.convertAndSend( "qwer",user.getUserName(),message -> {
                        return message;
                    } );
                }
                if(log.getLogRoomPrice()<i || log.getLogRoomPrice()<userMoney){
//                审核通过
                    roomService.updLogByIdTwo( log.getLogId() );
                    System.out.println("审核通过");
                    template.convertAndSend( "qwer",user.getUserName(),message -> {
                        return message;
                    } );
                }

            }
        }



    }
}
